︠7f05f58c-ff03-4db9-9416-b627d47ff95e︠
r"""

q_reversal - reverse space, time and spacetime

This is all done with conjugates.

AUTHORS:
    -- Doug Sweetser (2009): Initial version.
    
EXAMPLES:
    Test the various conjugates.
    sage: q1 = q(1, 2, 3, 4); q_time_rev = q(-1, 2, 3, 4); 
    sage: q_space_rev = q(1, -2, -3, -4); q_spacetime_rev = q(-1, -2, -3, -4)
    sage: q1.conj()==q_space_rev
    True
    sage: q1.conj().negate() == q_time_rev
    True
    sage: q1.negate()==q_spacetime_rev
    True
"""
#*****************************************************************************
#       Copyright (C) 2009 Doug Sweetser <sweetser@alum.mit.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
︡1357436e-2f81-42b9-9bf8-b9f1523d6d4f︡︡
︠4d798983-82af-4b0e-aa5b-2b4ea08b9161︠
class q(list):
    def __init__(self,t,x,y,z):
        self.t = t
        self.x = x
        self.y = y
        self.z = z
        list.__init__(self,[t,x,y,z])
    def __repr__(self):
        return "Quaternion tools."
    def show(self):
        print self.t, self.x, self.y, self.z
    def add(self, q2):
        return(q(self.t + q2.t, self.x + q2.x, self.y + q2.y, self.z + q2.z));
    def scalar_div(self, d):
        return(q(self.t/d, self.x/d, self.y/d, self.z/d));
    def scalar_x(self, d):
        return(q(self.t * d, self.x * d, self.y * d, self.z * d));
    def conj(self):
        return q(self.t, -self.x, -self.y, -self.z)
    def conj_1(self):
        return q(-self.t, self.x, -self.y, -self.z)   
    def conj_2(self):
        return q(-self.t, -self.x, self.y, -self.z)
    def conj_3(self):
        return q(-self.t, -self.x, -self.y, self.z)   
    def negate(self):
        return q(-self.t, -self.x, -self.y, -self.z)
︡5129d8d8-d355-4944-a63c-d298c4ba248c︡︡
︠b4a5d72b-d6cc-4fbd-8032-3263127a4079︠
q1 = q(1, 2, 3, 4); q_time_rev = q(-1, 2, 3, 4); 
q_space_rev = q(1, -2, -3, -4); q_spacetime_rev = q(-1, -2, -3, -4)

q1.conj()==q_space_rev
︡2c981e9a-f41b-4e95-acfa-cc65f2752d13︡{"stdout": "True"}︡
︠325566e3-72f2-42e3-a678-9700bc38bb6c︠
q1.conj().negate() == q_time_rev
︡eed9946a-f520-4371-9428-fd7f74599d56︡{"stdout": "True"}︡
︠da8eddb0-bfef-4e55-834c-f4d4f14f98cf︠
q1.negate()==q_spacetime_rev
︡a9dd49a4-2a17-4557-90f1-0d9e51091175︡{"stdout": "True"}︡
︠7ebfaa4b-fd90-4758-a480-0dc881a72bc7︠
r""" The space, time and spacetime reflections all are well defined on the quaternion manifold H^1, even if one customarily things of them in R^4.
︡0e40c994-5de4-40d8-8a79-19c85fcde46f︡︡
